Documentation: list git-credential in plumbing commands
[git.git] / git-submodule.sh
blobaac575e74f833c9bce28b779733b28a7611246b2
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-sh-i18n
18 . git-parse-remote
19 require_work_tree
21 command=
22 branch=
23 force=
24 reference=
25 cached=
26 recursive=
27 init=
28 files=
29 nofetch=
30 update=
31 prefix=
33 # The function takes at most 2 arguments. The first argument is the
34 # URL that navigates to the submodule origin repo. When relative, this URL
35 # is relative to the superproject origin URL repo. The second up_path
36 # argument, if specified, is the relative path that navigates
37 # from the submodule working tree to the superproject working tree.
39 # The output of the function is the origin URL of the submodule.
41 # The output will either be an absolute URL or filesystem path (if the
42 # superproject origin URL is an absolute URL or filesystem path,
43 # respectively) or a relative file system path (if the superproject
44 # origin URL is a relative file system path).
46 # When the output is a relative file system path, the path is either
47 # relative to the submodule working tree, if up_path is specified, or to
48 # the superproject working tree otherwise.
49 resolve_relative_url ()
51 remote=$(get_default_remote)
52 remoteurl=$(git config "remote.$remote.url") ||
53 remoteurl=$(pwd) # the repository is its own authoritative upstream
54 url="$1"
55 remoteurl=${remoteurl%/}
56 sep=/
57 up_path="$2"
59 case "$remoteurl" in
60 *:*|/*)
61 is_relative=
63 ./*|../*)
64 is_relative=t
67 is_relative=t
68 remoteurl="./$remoteurl"
70 esac
72 while test -n "$url"
74 case "$url" in
75 ../*)
76 url="${url#../}"
77 case "$remoteurl" in
78 */*)
79 remoteurl="${remoteurl%/*}"
81 *:*)
82 remoteurl="${remoteurl%:*}"
83 sep=:
86 if test -z "$is_relative" || test "." = "$remoteurl"
87 then
88 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
89 else
90 remoteurl=.
93 esac
95 ./*)
96 url="${url#./}"
99 break;;
100 esac
101 done
102 remoteurl="$remoteurl$sep${url%/}"
103 echo "${is_relative:+${up_path}}${remoteurl#./}"
107 # Get submodule info for registered submodules
108 # $@ = path to limit submodule list
110 module_list()
112 git ls-files --error-unmatch --stage -- "$@" |
113 perl -e '
114 my %unmerged = ();
115 my ($null_sha1) = ("0" x 40);
116 while (<STDIN>) {
117 chomp;
118 my ($mode, $sha1, $stage, $path) =
119 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
120 next unless $mode eq "160000";
121 if ($stage ne "0") {
122 if (!$unmerged{$path}++) {
123 print "$mode $null_sha1 U\t$path\n";
125 next;
127 print "$_\n";
133 # Map submodule path to submodule name
135 # $1 = path
137 module_name()
139 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
140 sm_path="$1"
141 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
142 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
143 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
144 test -z "$name" &&
145 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
146 echo "$name"
150 # Clone a submodule
152 # Prior to calling, cmd_update checks that a possibly existing
153 # path is not a git repository.
154 # Likewise, cmd_add checks that path does not exist at all,
155 # since it is the location of a new submodule.
157 module_clone()
159 sm_path=$1
160 url=$2
161 reference="$3"
162 quiet=
163 if test -n "$GIT_QUIET"
164 then
165 quiet=-q
168 gitdir=
169 gitdir_base=
170 name=$(module_name "$sm_path" 2>/dev/null)
171 test -n "$name" || name="$sm_path"
172 base_name=$(dirname "$name")
174 gitdir=$(git rev-parse --git-dir)
175 gitdir_base="$gitdir/modules/$base_name"
176 gitdir="$gitdir/modules/$name"
178 if test -d "$gitdir"
179 then
180 mkdir -p "$sm_path"
181 rm -f "$gitdir/index"
182 else
183 mkdir -p "$gitdir_base"
185 clear_local_git_env
186 git clone $quiet -n ${reference:+"$reference"} \
187 --separate-git-dir "$gitdir" "$url" "$sm_path"
188 ) ||
189 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
192 # We already are at the root of the work tree but cd_to_toplevel will
193 # resolve any symlinks that might be present in $PWD
194 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
195 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
196 # normalize Windows-style absolute paths to POSIX-style absolute paths
197 case $a in [a-zA-Z]:/*) a=/${a%%:*}${a#*:} ;; esac
198 case $b in [a-zA-Z]:/*) b=/${b%%:*}${b#*:} ;; esac
199 # Remove all common leading directories after a sanity check
200 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
201 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
203 while test "${a%%/*}" = "${b%%/*}"
205 a=${a#*/}
206 b=${b#*/}
207 done
208 # Now chop off the trailing '/'s that were added in the beginning
209 a=${a%/}
210 b=${b%/}
212 # Turn each leading "*/" component into "../"
213 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
214 echo "gitdir: $rel/$a" >"$sm_path/.git"
216 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
217 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
221 # Add a new submodule to the working tree, .gitmodules and the index
223 # $@ = repo path
225 # optional branch is stored in global branch variable
227 cmd_add()
229 # parse $args after "submodule ... add".
230 while test $# -ne 0
232 case "$1" in
233 -b | --branch)
234 case "$2" in '') usage ;; esac
235 branch=$2
236 shift
238 -f | --force)
239 force=$1
241 -q|--quiet)
242 GIT_QUIET=1
244 --reference)
245 case "$2" in '') usage ;; esac
246 reference="--reference=$2"
247 shift
249 --reference=*)
250 reference="$1"
251 shift
254 shift
255 break
258 usage
261 break
263 esac
264 shift
265 done
267 repo=$1
268 sm_path=$2
270 if test -z "$sm_path"; then
271 sm_path=$(echo "$repo" |
272 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
275 if test -z "$repo" -o -z "$sm_path"; then
276 usage
279 # assure repo is absolute or relative to parent
280 case "$repo" in
281 ./*|../*)
282 # dereference source url relative to parent's url
283 realrepo=$(resolve_relative_url "$repo") || exit
285 *:*|/*)
286 # absolute url
287 realrepo=$repo
290 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
292 esac
294 # normalize path:
295 # multiple //; leading ./; /./; /../; trailing /
296 sm_path=$(printf '%s/\n' "$sm_path" |
297 sed -e '
298 s|//*|/|g
299 s|^\(\./\)*||
300 s|/\./|/|g
301 :start
302 s|\([^/]*\)/\.\./||
303 tstart
304 s|/*$||
306 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
307 die "$(eval_gettext "'\$sm_path' already exists in the index")"
309 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
310 then
311 eval_gettextln "The following path is ignored by one of your .gitignore files:
312 \$sm_path
313 Use -f if you really want to add it." >&2
314 exit 1
317 # perhaps the path exists and is already a git repo, else clone it
318 if test -e "$sm_path"
319 then
320 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
321 then
322 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
323 else
324 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
327 else
329 module_clone "$sm_path" "$realrepo" "$reference" || exit
331 clear_local_git_env
332 cd "$sm_path" &&
333 # ash fails to wordsplit ${branch:+-b "$branch"...}
334 case "$branch" in
335 '') git checkout -f -q ;;
336 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
337 esac
338 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
340 git config submodule."$sm_path".url "$realrepo"
342 git add $force "$sm_path" ||
343 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
345 git config -f .gitmodules submodule."$sm_path".path "$sm_path" &&
346 git config -f .gitmodules submodule."$sm_path".url "$repo" &&
347 git add --force .gitmodules ||
348 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
352 # Execute an arbitrary command sequence in each checked out
353 # submodule
355 # $@ = command to execute
357 cmd_foreach()
359 # parse $args after "submodule ... foreach".
360 while test $# -ne 0
362 case "$1" in
363 -q|--quiet)
364 GIT_QUIET=1
366 --recursive)
367 recursive=1
370 usage
373 break
375 esac
376 shift
377 done
379 toplevel=$(pwd)
381 # dup stdin so that it can be restored when running the external
382 # command in the subshell (and a recursive call to this function)
383 exec 3<&0
385 module_list |
386 while read mode sha1 stage sm_path
388 if test -e "$sm_path"/.git
389 then
390 say "$(eval_gettext "Entering '\$prefix\$sm_path'")"
391 name=$(module_name "$sm_path")
393 prefix="$prefix$sm_path/"
394 clear_local_git_env
395 # we make $path available to scripts ...
396 path=$sm_path
397 cd "$sm_path" &&
398 eval "$@" &&
399 if test -n "$recursive"
400 then
401 cmd_foreach "--recursive" "$@"
403 ) <&3 3<&- ||
404 die "$(eval_gettext "Stopping at '\$sm_path'; script returned non-zero status.")"
406 done
410 # Register submodules in .git/config
412 # $@ = requested paths (default to all)
414 cmd_init()
416 # parse $args after "submodule ... init".
417 while test $# -ne 0
419 case "$1" in
420 -q|--quiet)
421 GIT_QUIET=1
424 shift
425 break
428 usage
431 break
433 esac
434 shift
435 done
437 module_list "$@" |
438 while read mode sha1 stage sm_path
440 name=$(module_name "$sm_path") || exit
442 # Copy url setting when it is not set yet
443 if test -z "$(git config "submodule.$name.url")"
444 then
445 url=$(git config -f .gitmodules submodule."$name".url)
446 test -z "$url" &&
447 die "$(eval_gettext "No url found for submodule path '\$sm_path' in .gitmodules")"
449 # Possibly a url relative to parent
450 case "$url" in
451 ./*|../*)
452 url=$(resolve_relative_url "$url") || exit
454 esac
455 git config submodule."$name".url "$url" ||
456 die "$(eval_gettext "Failed to register url for submodule path '\$sm_path'")"
458 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$sm_path'")"
461 # Copy "update" setting when it is not set yet
462 upd="$(git config -f .gitmodules submodule."$name".update)"
463 test -z "$upd" ||
464 test -n "$(git config submodule."$name".update)" ||
465 git config submodule."$name".update "$upd" ||
466 die "$(eval_gettext "Failed to register update mode for submodule path '\$sm_path'")"
467 done
471 # Update each submodule path to correct revision, using clone and checkout as needed
473 # $@ = requested paths (default to all)
475 cmd_update()
477 # parse $args after "submodule ... update".
478 orig_flags=
479 while test $# -ne 0
481 case "$1" in
482 -q|--quiet)
483 GIT_QUIET=1
485 -i|--init)
486 init=1
488 -N|--no-fetch)
489 nofetch=1
491 -f|--force)
492 force=$1
494 -r|--rebase)
495 update="rebase"
497 --reference)
498 case "$2" in '') usage ;; esac
499 reference="--reference=$2"
500 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
501 shift
503 --reference=*)
504 reference="$1"
506 -m|--merge)
507 update="merge"
509 --recursive)
510 recursive=1
512 --checkout)
513 update="checkout"
516 shift
517 break
520 usage
523 break
525 esac
526 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
527 shift
528 done
530 if test -n "$init"
531 then
532 cmd_init "--" "$@" || return
535 cloned_modules=
536 module_list "$@" | {
537 err=
538 while read mode sha1 stage sm_path
540 if test "$stage" = U
541 then
542 echo >&2 "Skipping unmerged submodule $sm_path"
543 continue
545 name=$(module_name "$sm_path") || exit
546 url=$(git config submodule."$name".url)
547 if ! test -z "$update"
548 then
549 update_module=$update
550 else
551 update_module=$(git config submodule."$name".update)
554 if test "$update_module" = "none"
555 then
556 echo "Skipping submodule '$sm_path'"
557 continue
560 if test -z "$url"
561 then
562 # Only mention uninitialized submodules when its
563 # path have been specified
564 test "$#" != "0" &&
565 say "$(eval_gettext "Submodule path '\$sm_path' not initialized
566 Maybe you want to use 'update --init'?")"
567 continue
570 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
571 then
572 module_clone "$sm_path" "$url" "$reference"|| exit
573 cloned_modules="$cloned_modules;$name"
574 subsha1=
575 else
576 subsha1=$(clear_local_git_env; cd "$sm_path" &&
577 git rev-parse --verify HEAD) ||
578 die "$(eval_gettext "Unable to find current revision in submodule path '\$sm_path'")"
581 if test "$subsha1" != "$sha1"
582 then
583 subforce=$force
584 # If we don't already have a -f flag and the submodule has never been checked out
585 if test -z "$subsha1" -a -z "$force"
586 then
587 subforce="-f"
590 if test -z "$nofetch"
591 then
592 # Run fetch only if $sha1 isn't present or it
593 # is not reachable from a ref.
594 (clear_local_git_env; cd "$sm_path" &&
595 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
596 test -z "$rev") || git-fetch)) ||
597 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
600 # Is this something we just cloned?
601 case ";$cloned_modules;" in
602 *";$name;"*)
603 # then there is no local change to integrate
604 update_module= ;;
605 esac
607 must_die_on_failure=
608 case "$update_module" in
609 rebase)
610 command="git rebase"
611 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$sm_path'")"
612 say_msg="$(eval_gettext "Submodule path '\$sm_path': rebased into '\$sha1'")"
613 must_die_on_failure=yes
615 merge)
616 command="git merge"
617 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$sm_path'")"
618 say_msg="$(eval_gettext "Submodule path '\$sm_path': merged in '\$sha1'")"
619 must_die_on_failure=yes
622 command="git checkout $subforce -q"
623 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$sm_path'")"
624 say_msg="$(eval_gettext "Submodule path '\$sm_path': checked out '\$sha1'")"
626 esac
628 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
629 then
630 say "$say_msg"
631 elif test -n "$must_die_on_failure"
632 then
633 die_with_status 2 "$die_msg"
634 else
635 err="${err};$die_msg"
636 continue
640 if test -n "$recursive"
641 then
642 (clear_local_git_env; cd "$sm_path" && eval cmd_update "$orig_flags")
643 res=$?
644 if test $res -gt 0
645 then
646 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
647 if test $res -eq 1
648 then
649 err="${err};$die_msg"
650 continue
651 else
652 die_with_status $res "$die_msg"
656 done
658 if test -n "$err"
659 then
660 OIFS=$IFS
661 IFS=';'
662 for e in $err
664 if test -n "$e"
665 then
666 echo >&2 "$e"
668 done
669 IFS=$OIFS
670 exit 1
675 set_name_rev () {
676 revname=$( (
677 clear_local_git_env
678 cd "$1" && {
679 git describe "$2" 2>/dev/null ||
680 git describe --tags "$2" 2>/dev/null ||
681 git describe --contains "$2" 2>/dev/null ||
682 git describe --all --always "$2"
685 test -z "$revname" || revname=" ($revname)"
688 # Show commit summary for submodules in index or working tree
690 # If '--cached' is given, show summary between index and given commit,
691 # or between working tree and given commit
693 # $@ = [commit (default 'HEAD'),] requested paths (default all)
695 cmd_summary() {
696 summary_limit=-1
697 for_status=
698 diff_cmd=diff-index
700 # parse $args after "submodule ... summary".
701 while test $# -ne 0
703 case "$1" in
704 --cached)
705 cached="$1"
707 --files)
708 files="$1"
710 --for-status)
711 for_status="$1"
713 -n|--summary-limit)
714 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
715 then
717 else
718 usage
720 shift
723 shift
724 break
727 usage
730 break
732 esac
733 shift
734 done
736 test $summary_limit = 0 && return
738 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
739 then
740 head=$rev
741 test $# = 0 || shift
742 elif test -z "$1" -o "$1" = "HEAD"
743 then
744 # before the first commit: compare with an empty tree
745 head=$(git hash-object -w -t tree --stdin </dev/null)
746 test -z "$1" || shift
747 else
748 head="HEAD"
751 if [ -n "$files" ]
752 then
753 test -n "$cached" &&
754 die "$(gettext "The --cached option cannot be used with the --files option")"
755 diff_cmd=diff-files
756 head=
759 cd_to_toplevel
760 # Get modified modules cared by user
761 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
762 sane_egrep '^:([0-7]* )?160000' |
763 while read mod_src mod_dst sha1_src sha1_dst status name
765 # Always show modules deleted or type-changed (blob<->module)
766 test $status = D -o $status = T && echo "$name" && continue
767 # Also show added or modified modules which are checked out
768 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
769 echo "$name"
770 done
773 test -z "$modules" && return
775 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
776 sane_egrep '^:([0-7]* )?160000' |
777 cut -c2- |
778 while read mod_src mod_dst sha1_src sha1_dst status name
780 if test -z "$cached" &&
781 test $sha1_dst = 0000000000000000000000000000000000000000
782 then
783 case "$mod_dst" in
784 160000)
785 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
787 100644 | 100755 | 120000)
788 sha1_dst=$(git hash-object $name)
790 000000)
791 ;; # removed
793 # unexpected type
794 eval_gettextln "unexpected mode \$mod_dst" >&2
795 continue ;;
796 esac
798 missing_src=
799 missing_dst=
801 test $mod_src = 160000 &&
802 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
803 missing_src=t
805 test $mod_dst = 160000 &&
806 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
807 missing_dst=t
809 total_commits=
810 case "$missing_src,$missing_dst" in
812 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
815 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
817 t,t)
818 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
821 errmsg=
822 total_commits=$(
823 if test $mod_src = 160000 -a $mod_dst = 160000
824 then
825 range="$sha1_src...$sha1_dst"
826 elif test $mod_src = 160000
827 then
828 range=$sha1_src
829 else
830 range=$sha1_dst
832 GIT_DIR="$name/.git" \
833 git rev-list --first-parent $range -- | wc -l
835 total_commits=" ($(($total_commits + 0)))"
837 esac
839 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
840 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
841 if test $status = T
842 then
843 blob="$(gettext "blob")"
844 submodule="$(gettext "submodule")"
845 if test $mod_dst = 160000
846 then
847 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
848 else
849 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
851 else
852 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
854 if test -n "$errmsg"
855 then
856 # Don't give error msg for modification whose dst is not submodule
857 # i.e. deleted or changed to blob
858 test $mod_dst = 160000 && echo "$errmsg"
859 else
860 if test $mod_src = 160000 -a $mod_dst = 160000
861 then
862 limit=
863 test $summary_limit -gt 0 && limit="-$summary_limit"
864 GIT_DIR="$name/.git" \
865 git log $limit --pretty='format: %m %s' \
866 --first-parent $sha1_src...$sha1_dst
867 elif test $mod_dst = 160000
868 then
869 GIT_DIR="$name/.git" \
870 git log --pretty='format: > %s' -1 $sha1_dst
871 else
872 GIT_DIR="$name/.git" \
873 git log --pretty='format: < %s' -1 $sha1_src
875 echo
877 echo
878 done |
879 if test -n "$for_status"; then
880 if [ -n "$files" ]; then
881 gettextln "# Submodules changed but not updated:"
882 else
883 gettextln "# Submodule changes to be committed:"
885 echo "#"
886 sed -e 's|^|# |' -e 's|^# $|#|'
887 else
892 # List all submodules, prefixed with:
893 # - submodule not initialized
894 # + different revision checked out
896 # If --cached was specified the revision in the index will be printed
897 # instead of the currently checked out revision.
899 # $@ = requested paths (default to all)
901 cmd_status()
903 # parse $args after "submodule ... status".
904 orig_flags=
905 while test $# -ne 0
907 case "$1" in
908 -q|--quiet)
909 GIT_QUIET=1
911 --cached)
912 cached=1
914 --recursive)
915 recursive=1
918 shift
919 break
922 usage
925 break
927 esac
928 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
929 shift
930 done
932 module_list "$@" |
933 while read mode sha1 stage sm_path
935 name=$(module_name "$sm_path") || exit
936 url=$(git config submodule."$name".url)
937 displaypath="$prefix$sm_path"
938 if test "$stage" = U
939 then
940 say "U$sha1 $displaypath"
941 continue
943 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
944 then
945 say "-$sha1 $displaypath"
946 continue;
948 set_name_rev "$sm_path" "$sha1"
949 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
950 then
951 say " $sha1 $displaypath$revname"
952 else
953 if test -z "$cached"
954 then
955 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
956 set_name_rev "$sm_path" "$sha1"
958 say "+$sha1 $displaypath$revname"
961 if test -n "$recursive"
962 then
964 prefix="$displaypath/"
965 clear_local_git_env
966 cd "$sm_path" &&
967 eval cmd_status "$orig_args"
968 ) ||
969 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
971 done
974 # Sync remote urls for submodules
975 # This makes the value for remote.$remote.url match the value
976 # specified in .gitmodules.
978 cmd_sync()
980 while test $# -ne 0
982 case "$1" in
983 -q|--quiet)
984 GIT_QUIET=1
985 shift
988 shift
989 break
992 usage
995 break
997 esac
998 done
999 cd_to_toplevel
1000 module_list "$@" |
1001 while read mode sha1 stage sm_path
1003 name=$(module_name "$sm_path")
1004 url=$(git config -f .gitmodules --get submodule."$name".url)
1006 # Possibly a url relative to parent
1007 case "$url" in
1008 ./*|../*)
1009 # rewrite foo/bar as ../.. to find path from
1010 # submodule work tree to superproject work tree
1011 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1012 # guarantee a trailing /
1013 up_path=${up_path%/}/ &&
1014 # path from submodule work tree to submodule origin repo
1015 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1016 # path from superproject work tree to submodule origin repo
1017 super_config_url=$(resolve_relative_url "$url") || exit
1020 sub_origin_url="$url"
1021 super_config_url="$url"
1023 esac
1025 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1026 then
1027 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
1028 git config submodule."$name".url "$super_config_url"
1030 if test -e "$sm_path"/.git
1031 then
1033 clear_local_git_env
1034 cd "$sm_path"
1035 remote=$(get_default_remote)
1036 git config remote."$remote".url "$sub_origin_url"
1040 done
1043 # This loop parses the command line arguments to find the
1044 # subcommand name to dispatch. Parsing of the subcommand specific
1045 # options are primarily done by the subcommand implementations.
1046 # Subcommand specific options such as --branch and --cached are
1047 # parsed here as well, for backward compatibility.
1049 while test $# != 0 && test -z "$command"
1051 case "$1" in
1052 add | foreach | init | update | status | summary | sync)
1053 command=$1
1055 -q|--quiet)
1056 GIT_QUIET=1
1058 -b|--branch)
1059 case "$2" in
1061 usage
1063 esac
1064 branch="$2"; shift
1066 --cached)
1067 cached="$1"
1070 break
1073 usage
1076 break
1078 esac
1079 shift
1080 done
1082 # No command word defaults to "status"
1083 test -n "$command" || command=status
1085 # "-b branch" is accepted only by "add"
1086 if test -n "$branch" && test "$command" != add
1087 then
1088 usage
1091 # "--cached" is accepted only by "status" and "summary"
1092 if test -n "$cached" && test "$command" != status -a "$command" != summary
1093 then
1094 usage
1097 "cmd_$command" "$@"